# Copyright (c) 2007 Michael "Z" Goddard
# This software is distributed under the MIT license.

"""
PyBlosxom Webfront Plugin

This plugin provides an alternative to editing your posts in your favorite 
text editor and ftp application, with a web front-end.
"""

pages_failed_import = False

from webfront import *
try:
    from pages import *
except ImportError, data:
    # Let it be known that the something failed to import
    # Inside of the handle, it will see if we are in the webfront if so, we 
    # will report this error.
    pages_failed_import = True
    pages_failed_data = data

__author__ = 'Michael "Z" Goddard <zera.goddard@gmail.com>'
__version__ = '$Id$'

VERSION = (0, 0)

def cb_start(args):
    request = args["request"]
    if Webfront.inWebfront(request):
        request.conf['depth'] = 1
    if Webfront.hasLoggedIn(request):
        data = request.data
        config = request.conf
        webfrontlink = config["base_url"] + "?edit=entry"
        defaulttext = "<a href='%s'>Webfront</a>"
        data["webfrontlink"] = config.get("webfront_link", defaulttext) % \
            webfrontlink
    # We need to make sure CONTENT_TYPE is in http otherwise the posted data
    # from a form will not decipher correctly
    if not request.http.has_key('CONTENT_TYPE'):
        request.http['CONTENT_TYPE'] = os.environ.get('CONTENT_TYPE', "")

def cb_handle(args):
    request = args["request"]
    if Webfront.inWebfront(request):
        if pages_failed_import:
            raise ImportError, data
        webfront = Webfront(request)
        webfront.handle()
        return webfront.handled
    if resource_punter(request):
        return 1

# def cb_story(args):
#     request = args['request']
#     if Webfront.hasLoggedIn(request):
#         entry = args['entry']
#         config = request.conf
#         editlink = config["base_url"] + entry.getId()[len( \
#             config["datadir"]):] + "?edit=edit"
#         defaulttext = "<a href='%s'>Edit</a>"
#         entry.setMetadata('editlink', config.get("webfront_editlink", \
#             defaulttext) % editlink)
#     return args

def cb_webfront_page(args):
    webfront = args['webfront']
    pages = args['pages']
    pages['new'] = new_handle
    pages['preview'] = preview_handle
    pages['file'] = file_handle
    pages['entry'] = EntryPage(webfront)
    pages['newdir'] = NewdirPage(webfront)
    pages['delete'] = DeletePage(webfront)
    pages['upload'] = UploadPage(webfront)
    pages['move'] = MovePage(webfront)
    pages['replace'] = ReplacePage(webfront)
    pages['login'] = LoginPage(webfront)
    
    #stuff using Cheetah templates so far
    pages['config'] = ConfigHandle()
    pages['edit'] = EditHandle()
    pages['entry-test'] = EntryHandle()
    
    base_url = webfront.config['base_url']
    pagelinks = args['pagelinks']
    pagelinks.append(("Posts", base_url + "?edit=entry&mode=post"))
    pagelinks.append(("Files", base_url + "?edit=entry&mode=file"))
    pagelinks.append(("Flavours", base_url + "?edit=entry&mode=flav"))

def cb_webfront_config(args):
    args['configurations'].append((register_configuration, "webfront", 5))

def cb_webfront_config_save(args):
    # special value clauses
    if args['name'] == 'blog_icbm':
        args['value'] = "%s, %s" % args['value']

