# (c) Copyright 2007 Michael "Z" Goddard. 
# This software is distributed under the MIT license.

"""
Assorted functions and code to assist testing.
"""

import os
import shutil

pjoin = os.path.join
isdir = os.path.isdir
isfile = os.path.isfile

def testPath():
    return pjoin(__file__[:__file__.rfind(os.sep)], "test")

def createTestDirectory():
    # make sure its gone first
    path = testPath()
    if os.access(path, os.F_OK):
        removeTestDirectory()
    os.mkdir(path)
    open(pjoin(path, 'text.txt'), 'w').write(
        """A title
        Some body""")
    open(pjoin(path, 'text2.txt'), 'w').write(
        """Another title
        more Body""")
    open(pjoin(path, '.hidden'), 'w').write(
        """I'm hidden
        hehehe""")

def removeTestDirectory():
    # make sure we have somethign to get rid of
    path = testPath()
    if os.access(path, os.F_OK):
        shutil.rmtree(path) # bye byes
